#include <iostream>

using namespace std;

int main()
{
    int width, height, z = 0,pom = 0;
    cin >> height >> width;
    int vodopad[width];
    for (int i = 0; i < width; ++i){
        vodopad[i] = 1;
    }
    int theMap[width][height];
    for(int i = 0; i<height; ++i)
    {
        for(int j = 0; j < width; ++j)
        {
            cin >> theMap[j][i];
        }
    }
    for(int i = 0; i<height; ++i)
    {
        for(int j = 0; j < width; ++j)
        {
            if(theMap[j][i]==0)
            {
                if(j == 0)
                {
                    z = j;
                    vodopad[j+1] += vodopad[j];
                    vodopad[j] = 0;
                    while(true)
                    {
                        if(theMap[z+1][i]==0)
                        {
                            vodopad[z+1] += vodopad[z];
                            vodopad[z] = 0;
                            z++;
                        }
                        else
                        {
                            vodopad[z+1] += vodopad[z];
                            vodopad[z] = 0;
                            z++;
                            break;
                        }
                    }
                }
                else if(j == width-1)
                {
                    z = j;
                    vodopad[j-1] += vodopad[j];
                    vodopad[j] = 0;
                    while(true)
                    {
                        if(theMap[z-1][i]==0)
                        {
                            vodopad[z-1] += vodopad[z];
                            vodopad[z] = 0;
                            z--;
                        }
                        else
                        {
                            vodopad[z-1] += vodopad[z];
                            vodopad[z] = 0;
                            z--;
                            break;
                        }
                    }

                }
                else
                {
                    vodopad[j-1] += vodopad[j]/2;
                    vodopad[j+1] += vodopad[j]/2;
                    if(vodopad[j]%2 == 1)
                    {
                        if((i+1)%2==0)
                            vodopad[j+1]++;
                        else vodopad[j-1]++;
                    }
                    vodopad[j] = 0;
                    int zlevo = j;
                    while(true)
                    {
                        if (zlevo < 0)
                        {
                            pom = vodopad[zlevo];
                            vodopad[zlevo] = 0;
                            break;
                        }
                        else if(theMap[zlevo-1][i]==0)
                        {
                            vodopad[zlevo-1] += vodopad[zlevo];
                            vodopad[zlevo] = 0;
                            zlevo--;
                        }
                        else
                        {
                            vodopad[zlevo-1] += vodopad[zlevo];
                            vodopad[zlevo] = 0;
                            break;
                        }
                    }
                    int zdesno = j;
                    while(true)
                    {
                        if (zdesno > width-2)
                        {
                            pom = vodopad[zdesno];
                            vodopad[zdesno]=0;
                            break;
                        }
                        else if(theMap[zdesno+1][i]==0)
                        {
                            vodopad[zdesno+1] += vodopad[zdesno];
                            vodopad[zdesno] = 0;
                            zdesno++;
                        }
                        else
                        {
                            vodopad[zdesno+1] += vodopad[zdesno];
                            vodopad[zdesno] = 0;
                            break;
                        }
                    }
                    if (zlevo < 0) vodopad[zdesno] += pom;
                    if(zdesno > width-2)vodopad[zlevo] +=pom;
                }
            }
        }
    }
    for (int i = 0; i < width; ++i){
        cout << vodopad[i] << " ";
    }
    return 0;
}